﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Enemy : MonoBehaviour {

    public int HP = 1;
    public float SPEED = 2;
    public GameObject[] AttackObj;
    public List<GameObject> InsAttackArr = new List<GameObject>();

    [SerializeField]
    private int[] Attacktiming = new int[]{
        1, 0, 0, 0, 0, 0, 0, 0,
        1, 0, 0, 0, 0, 0, 0, 0,
        1, 0, 0, 0, 0, 0, 0, 0,
        1, 0, 0, 0, 0, 0, 0, 0,
    };
    private float TimeCounter = 0;
    private int pos;
    private const float Interval = 0.25f;

    public bool IsAttack = false;

    public GameObject Effect;
    public ParticleSystem pa;
    public float WaiteTime = 0.5f;

    void Start(){
        IsAttack = false;
    }

	// Update is called once per frame
	void Update () {
        if (!IsAttack){
            return;
        }

        TimeCounter += Time.deltaTime;

        if (TimeCounter > Interval)
        {
            int inskind = -1;
            if (Attacktiming[pos] == 1){
                inskind = 0;
                AudioManager.Instance.PlaySE("normalwave");
            }

            if (Attacktiming[pos] == 2){
                inskind = 1;
                AudioManager.Instance.PlaySE("barrierwave");
            }

            if (Attacktiming[pos] == 3){
                inskind = 2;
                AudioManager.Instance.PlaySE("powerwave");
            }

            if (inskind >= 0){
                // 攻撃する
                GameObject obj = Instantiate(AttackObj[inskind], new Vector3(transform.position.x, 0.5f, transform.position.z), Quaternion.identity);
                obj.GetComponent<Wave>().moveSpeed = SPEED;
                this.InsAttackArr.Add(obj);
            }

            if (Attacktiming.Length -1 <= pos)
            {
                pos = 0;
            }
            else
            {
                pos++;
            }
            TimeCounter = 0;
        }
	}

    public void Ded(){
        HP--;
        AudioManager.Instance.PlaySE("EnemyDamage");
        if (HP <= 0)
        {
            if (IsAttack)
            {
                IsAttack = false;
                GetComponent<Collider>().enabled = false;
                StartCoroutine("des");
            }
        }
    }

    IEnumerator des(){
        AudioManager.Instance.PlaySE("charge");
        Effect.transform.parent = null;
        pa.Play();
        yield return new WaitForSeconds(WaiteTime);
        AudioManager.Instance.PlaySE("break");
        gameObject.GetComponentInParent<Stage>().enemy.Remove(this.gameObject);
        for (int i = 0; i < this.InsAttackArr.Count; i++)
        {
            if (this.InsAttackArr[i] != null)
            {
                Destroy(this.InsAttackArr[i]);
            }
        }
        Destroy(gameObject);
    }
}
