﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GameCondacter : MonoBehaviour {

    /// <summary>
    /// ウェーブ表示用クラス
    /// </summary>
    public LevelUP LU;

    /// <summary>
    /// ウェーブ数クラス
    /// </summary>
    private WaveManager WM;

    public EnemyFactor EF;
    public Worning2 Wing;

    public bool PlayerMoveFlag = false;

    [SerializeField]
    private float UpTimeScale = 0.2f;

    [SerializeField]
    private float DOWNSPEED;

	// Use this for initialization
	void Start () {
        WM = new WaveManager();
        LU.Init();
        LU.FadeIN(WM.wave);
        GameObject st = EF.Fact(WM.wave-1);
        StartCoroutine(MoveStage(st));
	}

    public void StageStart(){
        WM.WaveClear();
        int wave = WM.wave;
        LU.FadeIN(wave);
        if (wave != 0 && wave % 5 == 0)
        {
            Wing.FadeStart();
        }
        if (wave != 0 && wave % 20 == 0)
        {
            Time.timeScale += UpTimeScale;
        }

        GameObject st = EF.Fact(wave-1);
        StartCoroutine(MoveStage(st));
    }

    public void NextWaite(){
        PlayerMoveFlag = false;
        StartCoroutine(Waite(3));
    }

    IEnumerator Waite(float time){
        yield return new WaitForSeconds(time);
        StageStart();
    }

    IEnumerator MoveStage(GameObject st){
        while (st.transform.position.y > 0){
            st.transform.position += DOWNSPEED * Vector3.down * Time.deltaTime;
            yield return 0;
        }
        AudioManager.Instance.PlaySE("EnemyOnGrand");
        st.transform.position = Vector3.zero;
        Wing.FadeEnd();
        LU.FadeOUT();
        yield return new WaitForSeconds(LU.FadeTime);
        Stage S = st.GetComponent<Stage>();
        S.AttackStart();
        PlayerMoveFlag = true;
        S.GC = this;
    }

    public void GameOver(){
        PlayerPrefs.SetInt("Score", WM.wave);
        FadeManager.Instance.LoadLevel("Result");
    }
}
