﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class LevelUP : MonoBehaviour {

    public int Level;

    public float FadeTime;//フェード時間
    private float Fade;
    private const float FadeInterval = 1 / 60;

    public Sprite[] Numbers = new Sprite[10];//数字画像
    public Image WaveText;
    public Image Ten;//十の位イメージ
    public Image One;//一の位イメージ

    void LevelImageChange(int Level){
        int TenNum;//十の位
        int OneNum;//一の位

        //表示する数字を変更
        if(Level > 99){
            Level = 99;
        }
        if (Level < 10){
            //レベル1桁は「0X」で表示
            TenNum = 0;
            OneNum = Level;
        }
        else {
            TenNum = Level / 10;//十の位を取得
            OneNum = Level % 10;//一の位を取得
        }

        //画像変更
        Ten.sprite = Numbers[TenNum];
        One.sprite = Numbers[OneNum];
    }

    /// <summary>
    /// 初期化
    /// </summary>
    public void Init(){
        WaveText.color = new Color(WaveText.color.r, WaveText.color.g, WaveText.color.b, 0);
        Ten.color      = new Color(Ten.color.r, Ten.color.g, Ten.color.b, 0);
        One.color      = new Color(One.color.r, One.color.g, Ten.color.b, 0);
    }

    /// <summary>
    /// フェードイン
    /// </summary>
    /// <param name="nm">Nm.</param>
    public void FadeIN(int nm){
        StartCoroutine(FadeIn(nm));
    }

    /// <summary>
    /// フェードアウト
    /// </summary>
    public void FadeOUT(){
        StartCoroutine("FadeOut");
    }

    IEnumerator FadeIn(int Level){
        //画像イメージ変更
        LevelImageChange(Level);
        float alpha = 0;
        //出現
        while (true){
            alpha += Fade * Time.deltaTime;

            WaveText.color = new Color(WaveText.color.r, WaveText.color.g, WaveText.color.b, alpha);
            Ten.color      = new Color(Ten.color.r, Ten.color.g, Ten.color.b, alpha);
            One.color      = new Color(One.color.r, One.color.g, Ten.color.b, alpha);

            //出現で終了
            if(alpha > 1){
                break;
            }

            yield return new WaitForSeconds(FadeInterval);
        }
    }

    IEnumerator FadeOut(){
        //消滅
        float alpha = 1;

        while (true){
            alpha -= Fade * Time.deltaTime;

            WaveText.color = new Color(WaveText.color.r, WaveText.color.g, WaveText.color.b, alpha);
            Ten.color      = new Color(Ten.color.r, Ten.color.g, Ten.color.b, alpha);
            One.color      = new Color(One.color.r, One.color.g, Ten.color.b, alpha);

            //消滅で終了
            if(alpha < 0){
                break;
            }

            yield return new WaitForSeconds(FadeInterval);
        }
    }

	void Start () {
        Fade = 1 / FadeTime;//フェード量計算
	}
	
	void Update () {
        if (Input.GetKeyDown(KeyCode.I)){
            StartCoroutine(FadeIn(Level));
        }
        if (Input.GetKeyDown(KeyCode.O)){
            StartCoroutine(FadeOut());
        }
    }
}
